module Paginator
  extend ActiveSupport::Concern

  def paginate(model)
    total_count model
    return model.limit(limit).offset(offset) if model.respond_to?('limit')
    model[offset..limit]
  end

  private

  def limit
    return 12 if params[:limit].blank?
    params[:limit].to_i
  end

  def offset
    return 0 if params[:offset].blank?
    params[:offset].to_i
  end

  def total_count(model)
    headers['X-Total-Count'] = model.count
  end
end
