class V1::FeedController < ApplicationController
  include ::Paginator
  include ActivitiesFilterService
  before_action :authenticate_user!

  # GET v1/feed
  # GET v1/feed.json
  # Render all activities that logged user can see
  def index
    activities = paginate activities_followed
    render json: activities
  end

  private

  def activities_followed
    query = ""
    values = [""]

    # builds a query string to find all relevant activities
    current_user.watching.each do |watching|
        if !watching.respond_to?(:state) || watching.state == "published"
          # Activities that are made by, owned by, or change the object you follow should be found
          query += " (trackable_type = ? and trackable_id = ?) or (owner_type = ? and owner_id = ?) or (recipient_type = ? and recipient_id = ?) or"
          values << watching.class.to_s
          values << watching.id
          values << watching.class.to_s
          values << watching.id
          values << watching.class.to_s
          values << watching.id
        end
    end

    values[0] = query[0..-3] # remove trailing "or" on the query
    return PublicActivity::Activity.where(key: activities_filter).where(values).order(created_at: :desc)
  end

end
