class V1::StatisticsController < ApplicationController
  # GET v1/statistics
  # GET v1/statistics.json
  def index
    statistics = { count: count_learning_objects, month_publications: month_publications, month_downloads: month_downloads }
    render json: statistics
  end

  private

  def count_learning_objects
    LearningObject.where('state = ?', LearningObject.states[:published]).count
  end

  def month_publications
    LearningObject.where('extract (month from published_at) = ? and extract (year from published_at) = ?', Time.current.month, Time.current.year).count
  end

  def month_downloads
    Download.where('extract (month from created_at) = ? and extract (year from created_at) = ?', Time.current.month, Time.current.year).count
  end
end
