module Downloadable
  extend ActiveSupport::Concern

  included do
    has_many :downloads, as: :downloadable, dependent: :destroy
    has_many :package_items, as: :packageable, dependent: :destroy
    has_many :packages, through: :package_items, dependent: :destroy
  end

  def download(user, ip)
    Download.where(user: user, ip: ip, downloadable: self).first_or_create
  end

  def downloaded?(user, ip)
    !Download.where(user: user, ip: ip, downloadable: self).blank?
  end

  def download_link
    raise NotImplementedError
  end
end
