# == Schema Information
#
# Table name: institutions
#
#  id          :integer          not null, primary key
#  name        :string
#  address     :string
#  city        :string
#  country     :string
#  description :text
#  created_at  :datetime         not null
#  updated_at  :datetime         not null
#

class Institution < ApplicationRecord
  include Tagger
  include Trackable
  include Publisher

  has_and_belongs_to_many :users
  #has_many :learning_objects, as: :publisher
  #has_many :collections, as: :owner

  has_attached_file :avatar, styles: { medium: '300x300>', thumb: '60x60>' }, default_url: ''
  validates_attachment_content_type :avatar, content_type: ['image/jpg', 'image/jpeg', 'image/png', 'image/gif']

  validates_presence_of :name

  acts_as_paranoid
  has_paper_trail
end
