# == Schema Information
#
# Table name: roles
#
#  id          :integer          not null, primary key
#  name        :string
#  description :text
#  created_at  :datetime         not null
#  updated_at  :datetime         not null
#

class Role < ApplicationRecord
  has_and_belongs_to_many :users

  validates :name, presence: true, uniqueness: true

  def self.admin
    find_by(name: 'admin') || create!(name: 'admin')
  end

  def self.teacher
    find_by(name: 'teacher') || create!(name: 'teacher')
  end

  def self.student
    find_by(name: 'student') || create!(name: 'student')
  end

  def self.curator
    find_by(name: 'curator') || create!(name: 'curator')
  end

  def self.moderator
    find_by(name: 'moderator') || create!(name: 'moderator')
  end

  def self.editor
    find_by(name: 'editor') || create!(name: 'editor')
  end

  def self.supervisor
    find_by(name: 'supervisor') || create!(name: 'supervisor')
  end

  def self.submitter
    find_by(name: 'submitter') || create!(name: 'submitter')
  end
  
end
