class CollectionPolicy < ApplicationPolicy
  include SociablePolicy
  include FollowablePolicy
  include TaggablePolicy
  include SubjectablePolicy
  include StageablePolicy

  class Scope < Scope
    def resolve
      if user_exists?
        if user_can_edit?
          scope.all
        else
          scope.includes(:collection_items).where.not(:collection_items => {:collection_id => nil}).where("privacy = ? OR owner_id = ?", 'public', user.id)
        end
      else
        scope.includes(:collection_items).where.not(:collection_items => {:collection_id => nil}).where(privacy: 'public')
      end
    end
  end

  def index?
    record
  end

  def delete_object?
    record if owns?
  end

  def add_object?
    record if owns?
  end

  def create?
    record if owns?
  end

  def show?
    if record.private?
      record if owns?
    else
      record
    end
  end

  def update?
    record if owns?
  end

  def destroy?
    record if owns?
  end

  def add_learning_object?
    record if user_exists?
  end

  def remove_learning_object?
    record if owns?
  end

  def change_privacy?
    record if owns?
  end

  def owner
    record.owner
  end
end
