module PublisherPolicy

  class Scope < ApplicationPolicy::Scope
    attr_reader :user, :record, :scope

    def initialize(user, record, scope)
      @user = user
      @record = user
      @scope = scope
    end

    def resolve
      if user.nil?
        scope.where(privacy: 'public')
      elsif user_can_edit? || record == user
        scope.all
      else
        scope.where(privacy: 'public')
      end
    end
  end

  def show_all_drafts?
    record if same_user? || user_can_edit?
  end

  def show_liked_learning_objects?
    record if same_user? || user_can_edit?
  end

  def show_liked_collections?
    record if same_user? || user_can_edit?
  end

  def same_user?
    record == user
  end
end
