class CollectionItemSerializer < ActiveModel::Serializer
  cache key: 'collection_item', expires_in: 24.hours
  
  def collectionable
    if ( object.collectionable_type == "LearningObject" )
    	serializer = ::LearningObjectSerializer
    elsif ( object.public? || (current_user && ( object.owner?(current_user) || current_user.can_edit? )) )
    	serializer = ::CollectionMinSerializer
    end

    if ( !serializer.blank? )
    	serializer.new(object.collectionable, {scope: current_user, scope_name: :current_user}).serializable_hash
  	end
  end

  belongs_to :collectionable, polymorphic: true
  attributes :id, :position, :collectionable, :collectionable_type
end
