class UserSerializer < ActiveModel::Serializer
  cache key: 'user', expires_in: 4.hours, except: [ :complained, :followed ]

  def complained
    object.complained? current_user
  end

  def followed
    current_user.try( :following?, object)
  end

  def email
    object.email if (current_user != nil)&&(object.id == current_user.id || current_user.is_admin?)
  end

  def learning_objects_count
    object.learning_objects.where('state = ?', LearningObject.states[:published]).count
  end

  attributes :id, :email, :provider, :name, :description, :submitter_request, :education, :score, :cover, :role_ids, :institution_ids, :avatar, :likes_count, :followed, :complained, :follows_count, :learning_objects_count, :collections_count, :created_at, :updated_at
  has_many :subjects
end
