module SearchService
  SEARCH_CLASSES = %w(LearningObject Collection User).freeze

  class InvalidSearchError < StandardError; end

  def self.search(search, user)
    model = instance(search, user)
    model.search.results
  end

  def self.autocomplete(search, user)
    model = instance(search, user)
    model.autocomplete
  end

  def self.instance(search, user)
    raise InvalidSearchError unless search.valid?
    "SearchService::#{search.search_class}".constantize.new(search, user)
  end
end
