require_dependency 'dspace'

class DeleteBitstreamWorker
  include Sidekiq::Worker

  def perform(attachment_id = nil)
    attachment = LearningObject::Attachment.find(attachment_id)
    return false if attachment.blank? || !wait_bitstream(attachment)

    # Require dspace gem
    Bundler.require(*Rails.groups)

    DspaceService.create_client.bitstreams.delete(id: attachment.id_dspace)
  end

  private

  def wait_bitstream(attachment)
    if attachment.id_dspace.blank?
      Timeout.timeout(60) do
        sleep(1.0) while attachment.id_dspace.blank?
      end
    end
    true
  rescue Timeout::Error
    false
  end
end
